# This file was automatically generated by SWIG
package CQPerlExt;
require Exporter;
require DynaLoader;
@ISA = qw(Exporter DynaLoader);
package CQPerlExtc;
bootstrap CQPerlExt;
var_CQPerlExt_init();
@EXPORT = qw( );

# ---------- BASE METHODS -------------

package CQPerlExt;
use Carp qw();

###############################################################################
# The level of perl detail to provide in CQ API error messages can be
# configured per perl interpreter via the $::CQAPI_ERROR_LEVEL variable, or per
# process via the environment variable CQAPI_ERROR_LEVEL.
#
# The possible values are 0, 1, 2, and 3.
#
# 0 = raw message = No eval is used at all.  AUTOLOAD defines the chunk.
# 1 = the default = Eval is used.  Caller defines the chunk.
# 2 = add method  = As 1, but the CQ API name is added.
# 3 = stack trace = As 2, but the caller stack trace is added.
#
# Perl Script Example:   $::CQAPI_ERROR_LEVEL=2
# Windows Batch Example: set CQAPI_ERROR_LEVEL=2
# C Shell Example:       setenv CQAPI_ERROR_LEVEL 2
# UNIX SH Example:       CQAPI_ERROR_LEVEL=2; export CQAPI_ERROR_LEVEL
#
###############################################################################
sub GetErrorLevel()
{
    my $lvl;
    $lvl = $::CQAPI_ERROR_LEVEL;
    if (defined($lvl) && $lvl =~ /^\d+$/) {
        return $lvl;                            # return $lvl if set from perl
    }
    $lvl = $ENV{CQAPI_ERROR_LEVEL};
    if (defined($lvl) && $lvl =~ /^\d+$/) {
        return $lvl;                            # return $lvl if set in ENV
    }
    return 1;                                   # nothing set, return default
}

######################################################################
# AUTOLOAD - Intermediary handler for *every* perl API call.
#
# $AUTOLOAD = the name of the function called.
# @_ = parameter list, where $_[0] is the HASH ref tied to a package object.
######################################################################
sub AUTOLOAD
{
    # CQCore calls need the tied object in $_[0] instead of the HASH ref.
    #
    my @args = @_;
    my $save_err = $@;
    my $result;
    eval {
        $args[0] = tied( %{ $args[0] } )
    };
    Carp::confess($@) if $@;

    # $sub = CQCore API name from $AUTOLOAD, i.e. ObjectName_MethodName
    #
    (my $sub = $AUTOLOAD) =~ s/::/_/g;

    # $coderef = the *callable* CQCore subroutine reference
    #
    my $coderef = UNIVERSAL::can(__PACKAGE__."c", $sub)
      or Carp::croak "Undefined subroutine &$AUTOLOAD called";

    # For error level 0, provide a completely clean non-eval call to the API.
    # For other error levels, eval the API then die with a fixed up message.
    #
    my $error_level = GetErrorLevel();
    if (! $error_level ) {
        $result = &$coderef(@args);             # $result avoids redhat crash
        $@ = $save_err;
        return $result;
    }
    eval {
        $result = &$coderef(@args);             # $result avoids redhat crash
    };
    if (! $@) {                                 # no error: restore $@ & return
        $@ = $save_err;                         # cannot set $@ inside eval
        return $result;
    }

    # We have caught an error.  If the original message ended with newline no
    # chunk was appended, otherwise $@ = "$error at __FILE__ line __LINE__.\n".

    my $chunk = index($@, ' at '.__FILE__.' line ');
    if ($chunk == -1) {                         # no chunk: message had newline
        die($@) if $error_level == 1;           # lvl 1: dont force a chunk
    }
    else {
        substr($@, $chunk) = '';                # remove AUTOLOAD chunk
    }
    my ($file, $line) = (caller)[1,2];
    if ($error_level == 1) {                    # lvl 1: die with caller chunk
        die("$@ at $file line $line.\n");
    }
    if ($error_level == 2) {
        die("$@\n $AUTOLOAD called at $file line $line.\n");
    }
    local $Carp::CarpLevel = 1;
    Carp::confess("$@\n $AUTOLOAD called");     # lvl 2: function and trace
}


sub TIEHASH {
    my ($classname,$obj) = @_;
    return bless $obj, $classname;
}

sub CLEAR { }

sub this {
    my $ptr = shift;
    return tied(%$ptr);
}


# ------- FUNCTION WRAPPERS --------

package CQPerlExt;

*CQAdminSession_Build = *CQPerlExtc::CQAdminSession_Build;
*CQAdminSession_Unbuild = *CQPerlExtc::CQAdminSession_Unbuild;
*CQAdminSession_GetClassName = *CQPerlExtc::CQAdminSession_GetClassName;
*CQAttachment_GetClassName = *CQPerlExtc::CQAttachment_GetClassName;
*CQAttachmentField_GetClassName = *CQPerlExtc::CQAttachmentField_GetClassName;
*CQClearQuest_Build = *CQPerlExtc::CQClearQuest_Build;
*CQClearQuest_Unbuild = *CQPerlExtc::CQClearQuest_Unbuild;
*CQClearQuest_GetClassName = *CQPerlExtc::CQClearQuest_GetClassName;
*CQDatabase_GetClassName = *CQPerlExtc::CQDatabase_GetClassName;
*CQDatabaseDesc_GetClassName = *CQPerlExtc::CQDatabaseDesc_GetClassName;
*CQDbAccess_Build = *CQPerlExtc::CQDbAccess_Build;
*CQDbAccess_Unbuild = *CQPerlExtc::CQDbAccess_Unbuild;
*CQDbAccess_GetClassName = *CQPerlExtc::CQDbAccess_GetClassName;
*CQEmailRules_Build = *CQPerlExtc::CQEmailRules_Build;
*CQEmailRules_Unbuild = *CQPerlExtc::CQEmailRules_Unbuild;
*CQEmailRules_GetClassName = *CQPerlExtc::CQEmailRules_GetClassName;
*CQEntity_GetClassName = *CQPerlExtc::CQEntity_GetClassName;
*CQEntityDef_GetClassName = *CQPerlExtc::CQEntityDef_GetClassName;
*CQEventObject_GetClassName = *CQPerlExtc::CQEventObject_GetClassName;
*CQFieldInfo_GetClassName = *CQPerlExtc::CQFieldInfo_GetClassName;
*CQFieldFilter_GetClassName = *CQPerlExtc::CQFieldFilter_GetClassName;
*CQFieldFilters_GetClassName = *CQPerlExtc::CQFieldFilters_GetClassName;
*CQFilterNode_GetClassName = *CQPerlExtc::CQFilterNode_GetClassName;
*CQGroup_GetClassName = *CQPerlExtc::CQGroup_GetClassName;
*CQHistory_GetClassName = *CQPerlExtc::CQHistory_GetClassName;
*CQHistoryField_GetClassName = *CQPerlExtc::CQHistoryField_GetClassName;
*CQLink_GetClassName = *CQPerlExtc::CQLink_GetClassName;
*CQPackageRev_GetClassName = *CQPerlExtc::CQPackageRev_GetClassName;
*CQProductInfo_GetClassName = *CQPerlExtc::CQProductInfo_GetClassName;
*CQQueryDef_GetClassName = *CQPerlExtc::CQQueryDef_GetClassName;
*CQQueryFieldDef_GetClassName = *CQPerlExtc::CQQueryFieldDef_GetClassName;
*CQQueryFilterNode_GetClassName = *CQPerlExtc::CQQueryFilterNode_GetClassName;
*CQSession_Build = *CQPerlExtc::CQSession_Build;
*CQSession_Unbuild = *CQPerlExtc::CQSession_Unbuild;
*CQSession_GetClassName = *CQPerlExtc::CQSession_GetClassName;
*CQSchema_GetClassName = *CQPerlExtc::CQSchema_GetClassName;
*CQSchemaRev_GetClassName = *CQPerlExtc::CQSchemaRev_GetClassName;
*CQResultSet_GetClassName = *CQPerlExtc::CQResultSet_GetClassName;
*CQUser_GetClassName = *CQPerlExtc::CQUser_GetClassName;
*CQWorkSpaceMgr_GetClassName = *CQPerlExtc::CQWorkSpaceMgr_GetClassName;
*CQMailMsg_Build = *CQPerlExtc::CQMailMsg_Build;
*CQMailMsg_Unbuild = *CQPerlExtc::CQMailMsg_Unbuild;
*CQMailMsg_GetClassName = *CQPerlExtc::CQMailMsg_GetClassName;
*CQForm_GetClassName = *CQPerlExtc::CQForm_GetClassName;
*CQReportMgr_GetClassName = *CQPerlExtc::CQReportMgr_GetClassName;
*CQReportDef_GetClassName = *CQPerlExtc::CQReportDef_GetClassName;
*CQFolder_GetClassName = *CQPerlExtc::CQFolder_GetClassName;
*CQPermission_GetClassName = *CQPerlExtc::CQPermission_GetClassName;
*CQTextSearchDef_GetClassName = *CQPerlExtc::CQTextSearchDef_GetClassName;
*CQTextSearchFieldRangeDef_GetClassName = *CQPerlExtc::CQTextSearchFieldRangeDef_GetClassName;
*CQTextSearchHit_GetClassName = *CQPerlExtc::CQTextSearchHit_GetClassName;
*CQTextSearchResult_GetClassName = *CQPerlExtc::CQTextSearchResult_GetClassName;
*CQExporter_GetClassName = *CQPerlExtc::CQExporter_GetClassName;

############# Class : CQObject ##############

package CQObject;
@ISA = qw( CQPerlExt );
%OWNER = ();
sub DISOWN {
    my $self = shift;
    my $ptr = tied(%$self);
    delete $OWNER{$ptr};
    };

sub ACQUIRE {
    my $self = shift;
    my $ptr = tied(%$self);
    $OWNER{$ptr} = 1;
    };


############# Class : CQAdminSession ##############

package CQAdminSession;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*Build = *CQPerlExt::CQAdminSession_Build;
*Unbuild = *CQPerlExt::CQAdminSession_Unbuild;
*GetClassName = *CQPerlExt::CQAdminSession_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQAdminSession($self);
        delete $OWNER{$self};
    }
}




############# Class : CQAttachment ##############

package CQAttachment;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQAttachment_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQAttachment($self);
        delete $OWNER{$self};
    }
}




############# Class : CQAttachments ##############

package CQAttachments;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQAttachments($self);
        delete $OWNER{$self};
    }
}




############# Class : CQAttachmentField ##############

package CQAttachmentField;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQAttachmentField_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQAttachmentField($self);
        delete $OWNER{$self};
    }
}




############# Class : CQAttachmentFields ##############

package CQAttachmentFields;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQAttachmentFields($self);
        delete $OWNER{$self};
    }
}




############# Class : CQClearQuest ##############

package CQClearQuest;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*Build = *CQPerlExt::CQClearQuest_Build;
*Unbuild = *CQPerlExt::CQClearQuest_Unbuild;
*GetClassName = *CQPerlExt::CQClearQuest_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQClearQuest($self);
        delete $OWNER{$self};
    }
}




############# Class : CQDatabase ##############

package CQDatabase;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQDatabase_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQDatabase($self);
        delete $OWNER{$self};
    }
}




############# Class : CQDatabases ##############

package CQDatabases;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQDatabases($self);
        delete $OWNER{$self};
    }
}




############# Class : CQDatabaseDesc ##############

package CQDatabaseDesc;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQDatabaseDesc_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQDatabaseDesc($self);
        delete $OWNER{$self};
    }
}




############# Class : CQDatabaseDescs ##############

package CQDatabaseDescs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQDatabaseDescs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQDbAccess ##############

package CQDbAccess;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
*Build = *CQPerlExt::CQDbAccess_Build;
*Unbuild = *CQPerlExt::CQDbAccess_Unbuild;
*GetClassName = *CQPerlExt::CQDbAccess_GetClassName;



############# Class : CQEmailRules ##############

package CQEmailRules;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*Build = *CQPerlExt::CQEmailRules_Build;
*Unbuild = *CQPerlExt::CQEmailRules_Unbuild;
*GetClassName = *CQPerlExt::CQEmailRules_GetClassName;
sub new {
    my $self = shift;
    my @args = @_;
    $self = CQPerlExtc::new_CQEmailRules(@args);
    return undef if (!defined($self));
    bless $self, "CQEmailRules";
    $OWNER{$self} = 1;
    my %retval;
    tie %retval, "CQEmailRules", $self;
    return bless \%retval,"CQEmailRules";
}

sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEmailRules($self);
        delete $OWNER{$self};
    }
}




############# Class : CQEntity ##############

package CQEntity;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQEntity_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEntity($self);
        delete $OWNER{$self};
    }
}




############# Class : CQEntityDef ##############

package CQEntityDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQEntityDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEntityDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQEntityDefs ##############

package CQEntityDefs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEntityDefs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQEventObject ##############

package CQEventObject;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQEventObject_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEventObject($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFieldInfo ##############

package CQFieldInfo;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQFieldInfo_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFieldInfo($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFieldInfos ##############

package CQFieldInfos;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFieldInfos($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFieldFilter ##############

package CQFieldFilter;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQFieldFilter_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFieldFilter($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFieldFilters ##############

package CQFieldFilters;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQFieldFilters_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFieldFilters($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFilterNode ##############

package CQFilterNode;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQFilterNode_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFilterNode($self);
        delete $OWNER{$self};
    }
}




############# Class : CQGroup ##############

package CQGroup;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQGroup_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQGroup($self);
        delete $OWNER{$self};
    }
}




############# Class : CQGroups ##############

package CQGroups;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQGroups($self);
        delete $OWNER{$self};
    }
}




############# Class : CQHistory ##############

package CQHistory;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQHistory_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQHistory($self);
        delete $OWNER{$self};
    }
}




############# Class : CQHistories ##############

package CQHistories;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQHistories($self);
        delete $OWNER{$self};
    }
}




############# Class : CQHistoryField ##############

package CQHistoryField;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQHistoryField_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQHistoryField($self);
        delete $OWNER{$self};
    }
}




############# Class : CQHistoryFields ##############

package CQHistoryFields;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQHistoryFields($self);
        delete $OWNER{$self};
    }
}




############# Class : CQLink ##############

package CQLink;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQLink_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQLink($self);
        delete $OWNER{$self};
    }
}




############# Class : CQLinks ##############

package CQLinks;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQLinks($self);
        delete $OWNER{$self};
    }
}




############# Class : CQPackageRev ##############

package CQPackageRev;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQPackageRev_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQPackageRev($self);
        delete $OWNER{$self};
    }
}




############# Class : CQPackageRevs ##############

package CQPackageRevs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQPackageRevs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQProductInfo ##############

package CQProductInfo;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQProductInfo_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQProductInfo($self);
        delete $OWNER{$self};
    }
}




############# Class : CQQueryDef ##############

package CQQueryDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQQueryDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQQueryDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQQueryDefs ##############

package CQQueryDefs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQQueryDefs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQQueryFieldDef ##############

package CQQueryFieldDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQQueryFieldDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQQueryFieldDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQQueryFieldDefs ##############

package CQQueryFieldDefs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQQueryFieldDefs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQQueryFilterNode ##############

package CQQueryFilterNode;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQQueryFilterNode_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQQueryFilterNode($self);
        delete $OWNER{$self};
    }
}




############# Class : CQSession ##############

package CQSession;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*Build = *CQPerlExt::CQSession_Build;
*Unbuild = *CQPerlExt::CQSession_Unbuild;
*GetClassName = *CQPerlExt::CQSession_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQSession($self);
        delete $OWNER{$self};
    }
}




############# Class : CQSchema ##############

package CQSchema;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQSchema_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQSchema($self);
        delete $OWNER{$self};
    }
}




############# Class : CQSchemas ##############

package CQSchemas;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQSchemas($self);
        delete $OWNER{$self};
    }
}




############# Class : CQSchemaRev ##############

package CQSchemaRev;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQSchemaRev_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQSchemaRev($self);
        delete $OWNER{$self};
    }
}




############# Class : CQSchemaRevs ##############

package CQSchemaRevs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQSchemaRevs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQResultSet ##############

package CQResultSet;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQResultSet_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQResultSet($self);
        delete $OWNER{$self};
    }
}




############# Class : CQUser ##############

package CQUser;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQUser_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQUser($self);
        delete $OWNER{$self};
    }
}




############# Class : CQUsers ##############

package CQUsers;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQUsers($self);
        delete $OWNER{$self};
    }
}




############# Class : CQWorkSpaceMgr ##############

package CQWorkSpaceMgr;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQWorkSpaceMgr_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQWorkSpaceMgr($self);
        delete $OWNER{$self};
    }
}




############# Class : CQMailMsg ##############

package CQMailMsg;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*Build = *CQPerlExt::CQMailMsg_Build;
*Unbuild = *CQPerlExt::CQMailMsg_Unbuild;
*GetClassName = *CQPerlExt::CQMailMsg_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQMailMsg($self);
        delete $OWNER{$self};
    }
}




############# Class : CQForm ##############

package CQForm;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQForm_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQForm($self);
        delete $OWNER{$self};
    }
}




############# Class : CQReportMgr ##############

package CQReportMgr;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQReportMgr_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQReportMgr($self);
        delete $OWNER{$self};
    }
}




############# Class : CQReportDef ##############

package CQReportDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQReportDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQReportDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQEntities ##############

package CQEntities;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQEntities($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFolder ##############

package CQFolder;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQFolder_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFolder($self);
        delete $OWNER{$self};
    }
}




############# Class : CQFolders ##############

package CQFolders;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQFolders($self);
        delete $OWNER{$self};
    }
}




############# Class : CQPermission ##############

package CQPermission;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQPermission_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQPermission($self);
        delete $OWNER{$self};
    }
}




############# Class : CQPermissions ##############

package CQPermissions;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQPermissions($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchDef ##############

package CQTextSearchDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQTextSearchDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchFieldRangeDef ##############

package CQTextSearchFieldRangeDef;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQTextSearchFieldRangeDef_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchFieldRangeDef($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchFieldRangeDefs ##############

package CQTextSearchFieldRangeDefs;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchFieldRangeDefs($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchHit ##############

package CQTextSearchHit;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQTextSearchHit_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchHit($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchHits ##############

package CQTextSearchHits;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchHits($self);
        delete $OWNER{$self};
    }
}




############# Class : CQTextSearchResult ##############

package CQTextSearchResult;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQTextSearchResult_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQTextSearchResult($self);
        delete $OWNER{$self};
    }
}




############# Class : CQExporter ##############

package CQExporter;
@ISA = qw( CQPerlExt CQObject );
%OWNER = ();
%ITERATORS = ();
*GetClassName = *CQPerlExt::CQExporter_GetClassName;
sub DESTROY {
    my $self;
    my $save_err = $@;
    eval {$self = tied(%{$_[0]})};
    $@ = $save_err;
    if (defined($self)) {
        delete $ITERATORS{$self};
    }
    else {
        $self = $_[0];
    }
    if (exists $OWNER{$self}) {
        CQPerlExtc::delete_CQExporter($self);
        delete $OWNER{$self};
    }
}




# ------- VARIABLE STUBS --------

package CQPerlExt;

*CQ_SESSION_LOGON_NEW_SESSION = *CQPerlExtc::CQ_SESSION_LOGON_NEW_SESSION;
*CQ_SESSION_LOGON_USE_EXISTING = *CQPerlExtc::CQ_SESSION_LOGON_USE_EXISTING;
*CQ_SESSION_LOGON_NO_CACHE = *CQPerlExtc::CQ_SESSION_LOGON_NO_CACHE;
*CQ_SESSION_LOGON_NO_DIALOG = *CQPerlExtc::CQ_SESSION_LOGON_NO_DIALOG;
*CQ_SESSION_LOGON_NO_ENVIRONMENT = *CQPerlExtc::CQ_SESSION_LOGON_NO_ENVIRONMENT;
*CQ_SESSION_LOGON_DO_NOT_CACHE = *CQPerlExtc::CQ_SESSION_LOGON_DO_NOT_CACHE;
*CQ_SESSION_LOGOFF_ALLOW_REUSE = *CQPerlExtc::CQ_SESSION_LOGOFF_ALLOW_REUSE;
*CQ_SESSION_LOGOFF_END_SESSION = *CQPerlExtc::CQ_SESSION_LOGOFF_END_SESSION;
*CQ_OBJECTMODEL_VERSION_MAJOR = *CQPerlExtc::CQ_OBJECTMODEL_VERSION_MAJOR;
*CQ_OBJECTMODEL_VERSION_MINOR = *CQPerlExtc::CQ_OBJECTMODEL_VERSION_MINOR;
*CQ_SHARED_SESSION = *CQPerlExtc::CQ_SHARED_SESSION;
*CQ_PRIVATE_SESSION = *CQPerlExtc::CQ_PRIVATE_SESSION;
*CQ_ADMIN_SESSION = *CQPerlExtc::CQ_ADMIN_SESSION;
*CQ_SHARED_METADATA_SESSION = *CQPerlExtc::CQ_SHARED_METADATA_SESSION;
*CQ_REQ_ENTITY = *CQPerlExtc::CQ_REQ_ENTITY;
*CQ_AUX_ENTITY = *CQPerlExtc::CQ_AUX_ENTITY;
*CQ_ANY_ENTITY = *CQPerlExtc::CQ_ANY_ENTITY;
*CQ_MANDATORY = *CQPerlExtc::CQ_MANDATORY;
*CQ_OPTIONAL = *CQPerlExtc::CQ_OPTIONAL;
*CQ_READONLY = *CQPerlExtc::CQ_READONLY;
*CQ_USE_HOOK = *CQPerlExtc::CQ_USE_HOOK;
*CQ_SHORT_STRING = *CQPerlExtc::CQ_SHORT_STRING;
*CQ_MULTILINE_STRING = *CQPerlExtc::CQ_MULTILINE_STRING;
*CQ_INT = *CQPerlExtc::CQ_INT;
*CQ_DATE_TIME = *CQPerlExtc::CQ_DATE_TIME;
*CQ_REFERENCE = *CQPerlExtc::CQ_REFERENCE;
*CQ_REFERENCE_LIST = *CQPerlExtc::CQ_REFERENCE_LIST;
*CQ_ATTACHMENT_LIST = *CQPerlExtc::CQ_ATTACHMENT_LIST;
*CQ_ID = *CQPerlExtc::CQ_ID;
*CQ_STATE = *CQPerlExtc::CQ_STATE;
*CQ_JOURNAL = *CQPerlExtc::CQ_JOURNAL;
*CQ_DBID = *CQPerlExtc::CQ_DBID;
*CQ_STATETYPE = *CQPerlExtc::CQ_STATETYPE;
*CQ_RECORDTYPE = *CQPerlExtc::CQ_RECORDTYPE;
*CQ_FLOAT = *CQPerlExtc::CQ_FLOAT;
*CQ_BUTTON_CLICK = *CQPerlExtc::CQ_BUTTON_CLICK;
*CQ_SUBDIALOG_BUTTON_CLICK = *CQPerlExtc::CQ_SUBDIALOG_BUTTON_CLICK;
*CQ_ITEM_SELECTION = *CQPerlExtc::CQ_ITEM_SELECTION;
*CQ_ITEM_DBLCLICK = *CQPerlExtc::CQ_ITEM_DBLCLICK;
*CQ_CONTEXMENU_ITEM_SELECTION = *CQPerlExtc::CQ_CONTEXMENU_ITEM_SELECTION;
*CQ_CONTEXMENU_ITEM_CONDITION = *CQPerlExtc::CQ_CONTEXMENU_ITEM_CONDITION;
*CQ_SUBMIT = *CQPerlExtc::CQ_SUBMIT;
*CQ_MODIFY = *CQPerlExtc::CQ_MODIFY;
*CQ_CHANGE_STATE = *CQPerlExtc::CQ_CHANGE_STATE;
*CQ_DUPLICATE = *CQPerlExtc::CQ_DUPLICATE;
*CQ_UNDUPLICATE = *CQPerlExtc::CQ_UNDUPLICATE;
*CQ_IMPORT = *CQPerlExtc::CQ_IMPORT;
*CQ_DELETE = *CQPerlExtc::CQ_DELETE;
*CQ_BASE = *CQPerlExtc::CQ_BASE;
*CQ_RECORD_SCRIPT_ALIAS = *CQPerlExtc::CQ_RECORD_SCRIPT_ALIAS;
*CQ_CQCOPY = *CQPerlExtc::CQ_CQCOPY;
*CQ_CLOSED_CHOICE = *CQPerlExtc::CQ_CLOSED_CHOICE;
*CQ_OPEN_CHOICE = *CQPerlExtc::CQ_OPEN_CHOICE;
*CQ_SQL_SERVER = *CQPerlExtc::CQ_SQL_SERVER;
*CQ_MS_ACCESS = *CQPerlExtc::CQ_MS_ACCESS;
*CQ_SQL_ANYWHERE = *CQPerlExtc::CQ_SQL_ANYWHERE;
*CQ_ORACLE = *CQPerlExtc::CQ_ORACLE;
*CQ_DB2 = *CQPerlExtc::CQ_DB2;
*CQ_ATTACHMENTS_DBID_UK_SEQ = *CQPerlExtc::CQ_ATTACHMENTS_DBID_UK_SEQ;
*CQ_ATTACHMENTS_FILENAME_UK_SEQ = *CQPerlExtc::CQ_ATTACHMENTS_FILENAME_UK_SEQ;
*CQ_ATTACHMENTS_FILESIZE_UK_SEQ = *CQPerlExtc::CQ_ATTACHMENTS_FILESIZE_UK_SEQ;
*CQ_ATTACHMENTS_DESCRIPTION_UK_SEQ = *CQPerlExtc::CQ_ATTACHMENTS_DESCRIPTION_UK_SEQ;
*CQ_HISTORY_DBID_UK_SEQ = *CQPerlExtc::CQ_HISTORY_DBID_UK_SEQ;
*CQ_HISTORY_ACTION_TIMESTAMP_UK_SEQ = *CQPerlExtc::CQ_HISTORY_ACTION_TIMESTAMP_UK_SEQ;
*CQ_HISTORY_USER_NAME_UK_SEQ = *CQPerlExtc::CQ_HISTORY_USER_NAME_UK_SEQ;
*CQ_HISTORY_ACTION_NAME_UK_SEQ = *CQPerlExtc::CQ_HISTORY_ACTION_NAME_UK_SEQ;
*CQ_HISTORY_OLD_STATE_UK_SEQ = *CQPerlExtc::CQ_HISTORY_OLD_STATE_UK_SEQ;
*CQ_HISTORY_NEW_STATE_UK_SEQ = *CQPerlExtc::CQ_HISTORY_NEW_STATE_UK_SEQ;
*CQ_TEXT_MSG = *CQPerlExtc::CQ_TEXT_MSG;
*CQ_WARNING_MSG = *CQPerlExtc::CQ_WARNING_MSG;
*CQ_ERROR_MSG = *CQPerlExtc::CQ_ERROR_MSG;
*CQ_EXCEPTION_MSG = *CQPerlExtc::CQ_EXCEPTION_MSG;
*CQ_DEBUG_MSG = *CQPerlExtc::CQ_DEBUG_MSG;
*CQ_NO_ACCESS_PERMISSION = *CQPerlExtc::CQ_NO_ACCESS_PERMISSION;
*CQ_READ_ONLY_PERMISSION = *CQPerlExtc::CQ_READ_ONLY_PERMISSION;
*CQ_READ_WRITE_PERMISSION = *CQPerlExtc::CQ_READ_WRITE_PERMISSION;
*CQ_READ_LIMITED_PERMISSION = *CQPerlExtc::CQ_READ_LIMITED_PERMISSION;
*CQ_CHANGE_PERMISSION_PERMISSION = *CQPerlExtc::CQ_CHANGE_PERMISSION_PERMISSION;
*CQ_NAME_NOT_EXTENDED = *CQPerlExtc::CQ_NAME_NOT_EXTENDED;
*CQ_NAME_EXTENDED = *CQPerlExtc::CQ_NAME_EXTENDED;
*CQ_NAME_EXTEND_WHEN_NEEDED = *CQPerlExtc::CQ_NAME_EXTEND_WHEN_NEEDED;
*CQ_DYNAMIC_LIST_ADMIN = *CQPerlExtc::CQ_DYNAMIC_LIST_ADMIN;
*CQ_PUBLIC_FOLDER_ADMIN = *CQPerlExtc::CQ_PUBLIC_FOLDER_ADMIN;
*CQ_SECURITY_ADMIN = *CQPerlExtc::CQ_SECURITY_ADMIN;
*CQ_RAW_SQL_WRITER = *CQPerlExtc::CQ_RAW_SQL_WRITER;
*CQ_ALL_USERS_VISIBLE = *CQPerlExtc::CQ_ALL_USERS_VISIBLE;
*CQ_MULTI_SITE_ADMIN = *CQPerlExtc::CQ_MULTI_SITE_ADMIN;
*CQ_SUPER_USER = *CQPerlExtc::CQ_SUPER_USER;
*CQ_APP_BUILDER = *CQPerlExtc::CQ_APP_BUILDER;
*CQ_USER_ADMIN = *CQPerlExtc::CQ_USER_ADMIN;
*CQ_LDAP_FIRST_INVALID_NOW = *CQPerlExtc::CQ_LDAP_FIRST_INVALID_NOW;
*CQ_CQ_FIRST = *CQPerlExtc::CQ_CQ_FIRST;
*CQ_CQ_ONLY = *CQPerlExtc::CQ_CQ_ONLY;
*CQ_LDAP_AUTHENTICATION = *CQPerlExtc::CQ_LDAP_AUTHENTICATION;
*CQ_CQ_AUTHENTICATION = *CQPerlExtc::CQ_CQ_AUTHENTICATION;
*CQ_LDAP_SSL = *CQPerlExtc::CQ_LDAP_SSL;
*CQ_LDAP_TLS = *CQPerlExtc::CQ_LDAP_TLS;
*CQ_LDAP_NONE = *CQPerlExtc::CQ_LDAP_NONE;
*CQ_CQ_LOGIN_NAME = *CQPerlExtc::CQ_CQ_LOGIN_NAME;
*CQ_CQ_FULLNAME = *CQPerlExtc::CQ_CQ_FULLNAME;
*CQ_CQ_EMAIL = *CQPerlExtc::CQ_CQ_EMAIL;
*CQ_CQ_PHONE = *CQPerlExtc::CQ_CQ_PHONE;
*CQ_CQ_MISC_INFO = *CQPerlExtc::CQ_CQ_MISC_INFO;
*CQ_DATABASE_NAMETYPE = *CQPerlExtc::CQ_DATABASE_NAMETYPE;
*CQ_USER_NAMETYPE = *CQPerlExtc::CQ_USER_NAMETYPE;
*CQ_GROUP_NAMETYPE = *CQPerlExtc::CQ_GROUP_NAMETYPE;
*CQ_SCHEMA_NAMETYPE = *CQPerlExtc::CQ_SCHEMA_NAMETYPE;
*CQ_DBCOLUMN_NAMETYPE = *CQPerlExtc::CQ_DBCOLUMN_NAMETYPE;
*CQ_ENTITYDEF_NAMETYPE = *CQPerlExtc::CQ_ENTITYDEF_NAMETYPE;
*CQ_FIELDDEF_NAMETYPE = *CQPerlExtc::CQ_FIELDDEF_NAMETYPE;
*CQ_ACTIONDEF_NAMETYPE = *CQPerlExtc::CQ_ACTIONDEF_NAMETYPE;
*CQ_STATEDEF_NAMETYPE = *CQPerlExtc::CQ_STATEDEF_NAMETYPE;
*CQ_HOOKDEF_NAMETYPE = *CQPerlExtc::CQ_HOOKDEF_NAMETYPE;
*CQ_SCHEMA_AUDIT_CHECKOUT_TIME = *CQPerlExtc::CQ_SCHEMA_AUDIT_CHECKOUT_TIME;
*CQ_SCHEMA_AUDIT_CHECKOUT_USER = *CQPerlExtc::CQ_SCHEMA_AUDIT_CHECKOUT_USER;
*CQ_SCHEMA_AUDIT_CHECKIN_TIME = *CQPerlExtc::CQ_SCHEMA_AUDIT_CHECKIN_TIME;
*CQ_SCHEMA_AUDIT_CHECKIN_USER = *CQPerlExtc::CQ_SCHEMA_AUDIT_CHECKIN_USER;
*CQ_HAS_NO_VALUE = *CQPerlExtc::CQ_HAS_NO_VALUE;
*CQ_HAS_VALUE = *CQPerlExtc::CQ_HAS_VALUE;
*CQ_VALUE_NOT_AVAILABLE = *CQPerlExtc::CQ_VALUE_NOT_AVAILABLE;
*CQ_KNOWN_VALID = *CQPerlExtc::CQ_KNOWN_VALID;
*CQ_KNOWN_INVALID = *CQPerlExtc::CQ_KNOWN_INVALID;
*CQ_NEEDS_VALIDATION = *CQPerlExtc::CQ_NEEDS_VALIDATION;
*CQ_ENTITY_NOT_FOUND = *CQPerlExtc::CQ_ENTITY_NOT_FOUND;
*CQ_ENTITY_VISIBLE = *CQPerlExtc::CQ_ENTITY_VISIBLE;
*CQ_ENTITY_HIDDEN = *CQPerlExtc::CQ_ENTITY_HIDDEN;
*CQ_WORKSPACE_QUERY = *CQPerlExtc::CQ_WORKSPACE_QUERY;
*CQ_WORKSPACE_CHART = *CQPerlExtc::CQ_WORKSPACE_CHART;
*CQ_WORKSPACE_FOLDER = *CQPerlExtc::CQ_WORKSPACE_FOLDER;
*CQ_WORKSPACE_ERMFORMAT = *CQPerlExtc::CQ_WORKSPACE_ERMFORMAT;
*CQ_WORKSPACE_FAVORITES = *CQPerlExtc::CQ_WORKSPACE_FAVORITES;
*CQ_WORKSPACE_QUERY_PARAMETERS = *CQPerlExtc::CQ_WORKSPACE_QUERY_PARAMETERS;
*CQ_WORKSPACE_PREFERENCES = *CQPerlExtc::CQ_WORKSPACE_PREFERENCES;
*CQ_WORKSPACE_INPUT_TEMPLATE = *CQPerlExtc::CQ_WORKSPACE_INPUT_TEMPLATE;
*CQ_WORKSPACE_REPORT = *CQPerlExtc::CQ_WORKSPACE_REPORT;
*CQ_WORKSPACE_REPORT_FMT = *CQPerlExtc::CQ_WORKSPACE_REPORT_FMT;
*CQ_WORKSPACE_STARTUP_BUCKET_ARRAY = *CQPerlExtc::CQ_WORKSPACE_STARTUP_BUCKET_ARRAY;
*CQ_WORKSPACE_PUBLIC_FOLDER = *CQPerlExtc::CQ_WORKSPACE_PUBLIC_FOLDER;
*CQ_WORKSPACE_USER_FOLDER = *CQPerlExtc::CQ_WORKSPACE_USER_FOLDER;
*CQ_WORKSPACE_NAME_NOT_EXTENDED = *CQPerlExtc::CQ_WORKSPACE_NAME_NOT_EXTENDED;
*CQ_WORKSPACE_NAME_EXTENDED = *CQPerlExtc::CQ_WORKSPACE_NAME_EXTENDED;
*CQ_WORKSPACE_NAME_EXTEND_WHEN_NEEDED = *CQPerlExtc::CQ_WORKSPACE_NAME_EXTEND_WHEN_NEEDED;
*CQ_REPORT_FORMAT_HTML32 = *CQPerlExtc::CQ_REPORT_FORMAT_HTML32;
*CQ_REPORT_FORMAT_HTML40 = *CQPerlExtc::CQ_REPORT_FORMAT_HTML40;
*CQ_BOOL_OP_AND = *CQPerlExtc::CQ_BOOL_OP_AND;
*CQ_BOOL_OP_OR = *CQPerlExtc::CQ_BOOL_OP_OR;
*CQ_COMP_OP_EQ = *CQPerlExtc::CQ_COMP_OP_EQ;
*CQ_COMP_OP_NEQ = *CQPerlExtc::CQ_COMP_OP_NEQ;
*CQ_COMP_OP_LT = *CQPerlExtc::CQ_COMP_OP_LT;
*CQ_COMP_OP_LTE = *CQPerlExtc::CQ_COMP_OP_LTE;
*CQ_COMP_OP_GT = *CQPerlExtc::CQ_COMP_OP_GT;
*CQ_COMP_OP_GTE = *CQPerlExtc::CQ_COMP_OP_GTE;
*CQ_COMP_OP_LIKE = *CQPerlExtc::CQ_COMP_OP_LIKE;
*CQ_COMP_OP_NOT_LIKE = *CQPerlExtc::CQ_COMP_OP_NOT_LIKE;
*CQ_COMP_OP_BETWEEN = *CQPerlExtc::CQ_COMP_OP_BETWEEN;
*CQ_COMP_OP_NOT_BETWEEN = *CQPerlExtc::CQ_COMP_OP_NOT_BETWEEN;
*CQ_COMP_OP_IS_NULL = *CQPerlExtc::CQ_COMP_OP_IS_NULL;
*CQ_COMP_OP_IS_NOT_NULL = *CQPerlExtc::CQ_COMP_OP_IS_NOT_NULL;
*CQ_COMP_OP_IN = *CQPerlExtc::CQ_COMP_OP_IN;
*CQ_COMP_OP_NOT_IN = *CQPerlExtc::CQ_COMP_OP_NOT_IN;
*CQ_DB_AGGR_COUNT = *CQPerlExtc::CQ_DB_AGGR_COUNT;
*CQ_DB_AGGR_SUM = *CQPerlExtc::CQ_DB_AGGR_SUM;
*CQ_DB_AGGR_AVG = *CQPerlExtc::CQ_DB_AGGR_AVG;
*CQ_DB_AGGR_MIN = *CQPerlExtc::CQ_DB_AGGR_MIN;
*CQ_DB_AGGR_MAX = *CQPerlExtc::CQ_DB_AGGR_MAX;
*CQ_DB_DAY_FUNC = *CQPerlExtc::CQ_DB_DAY_FUNC;
*CQ_DB_WEEK_FUNC = *CQPerlExtc::CQ_DB_WEEK_FUNC;
*CQ_DB_MONTH_FUNC = *CQPerlExtc::CQ_DB_MONTH_FUNC;
*CQ_DB_YEAR_FUNC = *CQPerlExtc::CQ_DB_YEAR_FUNC;
*CQ_SORT_ASC = *CQPerlExtc::CQ_SORT_ASC;
*CQ_SORT_DESC = *CQPerlExtc::CQ_SORT_DESC;
*CQ_SUCCESS = *CQPerlExtc::CQ_SUCCESS;
*CQ_NO_DATA_FOUND = *CQPerlExtc::CQ_NO_DATA_FOUND;
*CQ_MAX_ROWS_EXCEEDED = *CQPerlExtc::CQ_MAX_ROWS_EXCEEDED;
*CQ_ROW_DELETED = *CQPerlExtc::CQ_ROW_DELETED;
*CQ_LIST_QUERY = *CQPerlExtc::CQ_LIST_QUERY;
*CQ_REPORT_QUERY = *CQPerlExtc::CQ_REPORT_QUERY;
*CQ_CHART_QUERY = *CQPerlExtc::CQ_CHART_QUERY;
*CQ_HARD_QUERY_LIMIT = *CQPerlExtc::CQ_HARD_QUERY_LIMIT;
*CQ_SOFT_QUERY_LIMIT = *CQPerlExtc::CQ_SOFT_QUERY_LIMIT;
*CQ_CURSOR_FORWARD_ONLY = *CQPerlExtc::CQ_CURSOR_FORWARD_ONLY;
*CQ_CURSOR_SCROLLING = *CQPerlExtc::CQ_CURSOR_SCROLLING;
*CQ_RETURN_STRING_LOCAL = *CQPerlExtc::CQ_RETURN_STRING_LOCAL;
*CQ_RETURN_STRING_UNICODE = *CQPerlExtc::CQ_RETURN_STRING_UNICODE;
*PD_C_CHAR = *CQPerlExtc::PD_C_CHAR;
*PD_C_LONGVARCHAR = *CQPerlExtc::PD_C_LONGVARCHAR;
*PD_C_LONGVARBINARY = *CQPerlExtc::PD_C_LONGVARBINARY;
*PD_C_SLONG = *CQPerlExtc::PD_C_SLONG;
*PD_C_TIMESTAMP = *CQPerlExtc::PD_C_TIMESTAMP;
*PD_C_DOUBLE = *CQPerlExtc::PD_C_DOUBLE;
*CQ_TEXTSEARCH_NORMAL = *CQPerlExtc::CQ_TEXTSEARCH_NORMAL;
*CQ_TEXTSEARCH_TYPEAHEAD = *CQPerlExtc::CQ_TEXTSEARCH_TYPEAHEAD;
*CQ_TEXTSEARCH_CHOICELIST = *CQPerlExtc::CQ_TEXTSEARCH_CHOICELIST;
1;
